
import processing.video.*;

Movie myMovie;
int frameCounter = 0;

void setup() {
  size(640, 480, P2D);

  // open movie "littlemovie.mov"
  myMovie = new Movie(this, "littlemovie.mov");
  
  // set movie to loop
  myMovie.loop();
  
  // draw ellipses from the center...
  ellipseMode(CENTER);
  
  // ... and without border
  noStroke();
}

void draw() {
  background(110);
  
  // show movie frame on screen
  image(myMovie, width/4, height/4);
  
  // check for mouse button press
  if(mousePressed) {
     // draw red point on screen at mouse position
     fill(220, 10, 10);
     ellipse(mouseX, mouseY, 15, 15);
  }

  // add one to frame counter  
  frameCounter++;
  
  // display frame counter in left upper corner
  textSize(20);
  fill(0, 0, 30);
  text("" + frameCounter, 10, 30); 
}

// Called every time a new frame is available to read
void movieEvent(Movie m) {
  m.read();
}
