
import processing.video.*;

Movie myMovie;

int frameCounter = 0;
int TOTAL_FRAMES = 120;
int[] framesX;
int[] framesY;

void setup() {
  size(640, 480, P2D);
  
  // open movie "littlemovie.mov"
  myMovie = new Movie(this, "littlemovie.mov");
  
  // set movie to loop
  myMovie.loop();
  
  // draw ellipses from the center...
  ellipseMode(CENTER);
  
  // ... and without border
  noStroke();
  
  // reserve memory for saving x and y positions
  framesX = new int[TOTAL_FRAMES];
  framesY = new int[TOTAL_FRAMES];
}

void draw() {
  background(110);
  
  // show movie frame on screen
  image(myMovie, width/4, height/4);
  
  // check for mouse button press
  if(mousePressed) {
     // draw red point on screen at mouse position
     fill(220, 10, 10);
     ellipse(mouseX, mouseY, 15, 15);
  }

  // add one to frame counter  
  frameCounter = (frameCounter + 1) % TOTAL_FRAMES;
  
  // display frame counter in left upper corner
  textSize(20);
  fill(0, 0, 30);
  text("" + frameCounter, 10, 30); 

  if(mousePressed) {
     // draw point on screen
     fill(220, 10, 10);
     ellipse(mouseX, mouseY, 5, 5);
     
     // save point to memory
     framesX[frameCounter] = mouseX;
     framesY[frameCounter] = mouseY;
  } else {
     // draw point on screen from memory
     fill(10, 10, 220);
     ellipse(framesX[frameCounter], framesY[frameCounter], 5, 5);
  }
}

// Called every time a new frame is available to read
void movieEvent(Movie m) {
  m.read();
}
